import { w as writable } from './index2-tmoQ0rf3.js';

let locale_lang = writable("en");
function getLocale(date) {
  let locale;
  const unsubscribe = locale_lang.subscribe((value) => {
    locale = value;
  });
  unsubscribe();
  const cool_date = new Date(date);
  return {
    locale,
    date: cool_date
  };
}
function formatDate(date) {
  let data = getLocale(date);
  const options = { day: "numeric", month: "long", year: "numeric" };
  return data.date.toLocaleDateString(data.locale, options);
}
function formatDateMobile(date) {
  let data = getLocale(date);
  const options = { month: "numeric", year: "numeric" };
  return data.date.toLocaleDateString(data.locale, options);
}
function formatMonth(date) {
  let data = getLocale(date);
  const options = { month: "long", year: "numeric" };
  return data.date.toLocaleDateString(data.locale, options);
}
function formatYear(date) {
  let data = getLocale(date);
  const options = { year: "numeric" };
  return data.date.toLocaleDateString(data.locale, options);
}

async function load(context) {
  async function fetchData(data) {
    try {
      const resTemp = await context.fetch(`http://0.0.0.0:8000/${data}`);
      if (resTemp.ok == false) {
        return {
          status: resTemp.status
        };
      }
      return {
        status: 0,
        data: await resTemp.json()
      };
    } catch (error) {
      return {
        status: 500
      };
    }
  }
  async function fetchJSON(lang2) {
    try {
      const data = /* @__PURE__ */ Object.assign({ "/src/lib/lang/en.json": () => import('./en-OFzmJoKr.js'), "/src/lib/lang/fr.json": () => import('./fr-ySRlmSZA.js') });
      const file = data[`/src/lib/lang/${lang2}.json`];
      const jsonData2 = (await file()).default;
      return {
        status: 0,
        data: jsonData2
      };
    } catch {
      return {
        status: 500
      };
    }
  }
  const lang = context.params.lang;
  locale_lang.set(lang);
  let lang_id;
  const res = await fetchData(`get_lang_id/${lang}`);
  if (res.status == 500)
    return {
      status: res.status
    };
  else {
    lang_id = res.data.id;
  }
  let text;
  const jsonData = await fetchJSON(lang);
  if (jsonData.status == 0)
    text = jsonData.data;
  else {
    return {
      status: res.status
    };
  }
  const infos = [];
  const dataToGather = [
    `info/${lang_id}`,
    `education/${lang_id}`,
    `experience/${lang_id}`,
    `project/${lang_id}`,
    "hard_skills",
    "tags",
    `getproject_programming/${lang_id}`,
    `categories/${lang_id}`
  ];
  for (const url of dataToGather) {
    const res2 = await fetchData(url);
    if (res2.status == 0) {
      infos.push(res2.data);
    } else {
      return {
        status: res2.status
      };
    }
  }
  return {
    status: 0,
    lang,
    info: infos[0][0],
    education: infos[1],
    experience: infos[2],
    project: infos[3],
    languages: infos[4][0],
    skills: infos[4][1],
    tags: infos[5],
    project_skills: infos[6],
    categories: infos[7],
    text
  };
}

var _page = /*#__PURE__*/Object.freeze({
  __proto__: null,
  load: load
});

const index = 3;
let component_cache;
const component = async () => component_cache ??= (await import('./_page.svelte-zk0-jMFc.js')).default;
const universal_id = "src/routes/lang=[lang]/+page.js";
const imports = ["_app/immutable/nodes/3.dvu1y435.js","_app/immutable/chunks/3.FxjrB1o5.js","_app/immutable/chunks/preload-helper.0HuHagjb.js","_app/immutable/chunks/index.7bhxUoJF.js","_app/immutable/chunks/scheduler.scM5YSSR.js","_app/immutable/chunks/index.bw5h2akU.js"];
const stylesheets = ["_app/immutable/assets/3.iPSA5q-x.css","_app/immutable/assets/sidebar.dCT7c3Xf.css"];
const fonts = [];

var _3 = /*#__PURE__*/Object.freeze({
  __proto__: null,
  component: component,
  fonts: fonts,
  imports: imports,
  index: index,
  stylesheets: stylesheets,
  universal: _page,
  universal_id: universal_id
});

export { _3 as _, formatDate as a, formatDateMobile as b, formatMonth as c, formatYear as f };
//# sourceMappingURL=3-sChO4aMv.js.map
